<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.xmlextra</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;xmlextra
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== MODULE DESCRIPTION ==================== -->
<h1 class="epydoc">Module xmlextra</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html">source&nbsp;code</a></span></p>
Extension to libxml2 for XMPP stream and stanza processing

<!-- ==================== CLASSES ==================== -->
<a name="section-Classes"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Classes</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Classes"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.xmlextra.StreamHandler-class.html" class="summary-name">StreamHandler</a><br />
      Base class for stream handler.
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.xmlextra._SAXCallback-class.html" class="summary-name" onclick="show_private();">_SAXCallback</a><br />
      SAX events handler for the python-only stream parser.
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.xmlextra._PythonReader-class.html" class="summary-name" onclick="show_private();">_PythonReader</a><br />
      Python-only stream reader.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.xmlextra.StreamReader-class.html" class="summary-name">StreamReader</a><br />
      A simple push-parser interface for XML streams.
    </td>
  </tr>
</table>
<!-- ==================== FUNCTIONS ==================== -->
<a name="section-Functions"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Functions</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Functions"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_escape"></a><span class="summary-sig-name">_escape</span>(<span class="summary-sig-arg">data</span>)</span><br />
      Escape data for XML</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#_escape">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#_get_ns" class="summary-sig-name" onclick="show_private();">_get_ns</a>(<span class="summary-sig-arg">node</span>)</span><br />
      Get namespace of node.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#_get_ns">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#replace_ns" class="summary-sig-name">replace_ns</a>(<span class="summary-sig-arg">node</span>,
        <span class="summary-sig-arg">old_ns</span>,
        <span class="summary-sig-arg">new_ns</span>)</span><br />
      Replace namespaces in a whole subtree.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#replace_ns">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">libxml2.xmlNs</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#get_node_ns" class="summary-sig-name">get_node_ns</a>(<span class="summary-sig-arg">xmlnode</span>)</span><br />
      Namespace of an XML node.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#get_node_ns">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">unicode</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#get_node_ns_uri" class="summary-sig-name">get_node_ns_uri</a>(<span class="summary-sig-arg">xmlnode</span>)</span><br />
      Return namespace URI of an XML node.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#get_node_ns_uri">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#xml_node_iter" class="summary-sig-name">xml_node_iter</a>(<span class="summary-sig-arg">nodelist</span>)</span><br />
      Iterate over sibling XML nodes.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_node_iter">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#xml_element_iter" class="summary-sig-name">xml_element_iter</a>(<span class="summary-sig-arg">nodelist</span>)</span><br />
      Iterate over sibling XML elements.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_element_iter">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#xml_element_ns_iter" class="summary-sig-name">xml_element_ns_iter</a>(<span class="summary-sig-arg">nodelist</span>,
        <span class="summary-sig-arg">ns_uri</span>)</span><br />
      Iterate over sibling XML elements.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_element_ns_iter">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="remove_evil_characters"></a><span class="summary-sig-name">remove_evil_characters</span>(<span class="summary-sig-arg">s</span>)</span><br />
      Remove control characters (not allowed in XML) from a string.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#remove_evil_characters">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">string</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.xmlextra-module.html#safe_serialize" class="summary-sig-name">safe_serialize</a>(<span class="summary-sig-arg">xmlnode</span>)</span><br />
      Serialize an XML element making sure the result is sane.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#safe_serialize">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== VARIABLES ==================== -->
<a name="section-Variables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Variables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="common_doc"></a><span class="summary-name">common_doc</span> = <code title="libxml2.newDoc(&quot;1.0&quot;)">libxml2.newDoc(&quot;1.0&quot;)</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="common_root"></a><span class="summary-name">common_root</span> = <code title="common_doc.newChild(None, &quot;root&quot;, None)">common_doc.newChild(None, &quot;root&quot;, None)</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="COMMON_NS"></a><span class="summary-name">COMMON_NS</span> = <code title="'http://pyxmpp.jajcus.net/xmlns/common'"><code class="variable-quote">'</code><code class="variable-string">http://pyxmpp.jajcus.net/xmlns/common</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="common_ns"></a><span class="summary-name">common_ns</span> = <code title="common_root.newNs(COMMON_NS, None)">common_root.newNs(COMMON_NS, None)</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="logger"></a><span class="summary-name">logger</span> = <code title="logging.getLogger(&quot;pyxmpp.xmlextra&quot;)">logging.getLogger(&quot;pyxmpp.xmlextra&quot;)</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="pure_python"></a><span class="summary-name">pure_python</span> = <code title="False">False</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="evil_characters_re"></a><span class="summary-name">evil_characters_re</span> = <code title="re.compile(r'(?u)[\x00-\x08\v\f\x0e-\x1f]')">re.compile(r'<code class="re-flags">(?u)</code><code class="re-group">[</code>\x00<code class="re-op">-</code>\x08\v\f\x0e<code class="re-op">-</code>\x1f<code class="re-group">]</code>')</code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="utf8_replacement_char"></a><span class="summary-name">utf8_replacement_char</span> = <code title="'\xef\xbf\xbd'"><code class="variable-quote">'</code><code class="variable-string">\xef\xbf\xbd</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a href="pyxmpp.xmlextra-module.html#bad_nsdef_replace_re" class="summary-name">bad_nsdef_replace_re</a> = <code title="re.compile(r'^([^&lt;]*&lt;[^&gt;&lt;]*\s+)(xmlns=((&quot;[^&quot;]*&quot;)|(\'[^\']*\')))')">re.compile(r'^<code class="re-group">(</code><code class="re-group">[^</code>&lt;<code class="re-group">]</code><code class="re-op">*</code>&lt;<code class="re-group">[</code><code class="re-op">^</code>&gt;&lt;<code class="re-group">]</code><code class="re-op">*</code>\s<code class="re-op">+</code><code class="re-group">)</code><code class="re-group">(</code>xmlns=<code class="re-group">(</code><code class="variable-ellipsis">...</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="__package__"></a><span class="summary-name">__package__</span> = <code title="'pyxmpp'"><code class="variable-quote">'</code><code class="variable-string">pyxmpp</code><code class="variable-quote">'</code></code>
    </td>
  </tr>
</table>
<p class="indent-wrapped-lines"><b>Imports:</b>
  <span title="sys">sys</span>,
  <span title="libxml2">libxml2</span>,
  <span title="threading">threading</span>,
  <span title="re">re</span>,
  <span title="logging">logging</span>,
  <a href="pyxmpp.exceptions.StreamParseError-class.html" title="pyxmpp.exceptions.StreamParseError">StreamParseError</a>,
  <a href="pyxmpp._xmlextra-module.html" title="pyxmpp._xmlextra">_xmlextra</a>,
  <span title="pyxmpp.xmlextra.error">error</span>,
  <a href="pyxmpp._xmlextra-module.html#sax_reader_new" title="pyxmpp._xmlextra.sax_reader_new">_create_reader</a>
</p><br />
<!-- ==================== FUNCTION DETAILS ==================== -->
<a name="section-FunctionDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Function Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-FunctionDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="_get_ns"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_get_ns</span>(<span class="sig-arg">node</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#_get_ns">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Get namespace of node.</p>
<p>assigned.
:returntype: <code class="link">libxml2.xmlNs</code></p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>the namespace object or <code class="link">None</code> if the node has no namespace</dd>
  </dl>
</td></tr></table>
</div>
<a name="replace_ns"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">replace_ns</span>(<span class="sig-arg">node</span>,
        <span class="sig-arg">old_ns</span>,
        <span class="sig-arg">new_ns</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#replace_ns">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Replace namespaces in a whole subtree.</p>
<p>The old namespace declaration will be removed if present on the <code class="link">node</code>.</p>
<p>Both old_ns and new_ns may be None meaning no namespace set.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>node</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the root of the subtree where namespaces should be replaced.</li>
        <li><strong class="pname"><code>old_ns</code></strong> (: <code class="link">libxml2.xmlNs</code>) - : the namespace to replace.</li>
        <li><strong class="pname"><code>new_ns</code></strong> (: <code class="link">libxml2.xmlNs</code>) - : the namespace to be used instead of old_ns.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="get_node_ns"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_node_ns</span>(<span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#get_node_ns">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Namespace of an XML node.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the XML node to query.</li>
    </ul></dd>
    <dt>Returns: <code class="link">libxml2.xmlNs</code></dt>
        <dd>namespace of the node or <code class="link">None</code></dd>
  </dl>
</td></tr></table>
</div>
<a name="get_node_ns_uri"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_node_ns_uri</span>(<span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#get_node_ns_uri">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Return namespace URI of an XML node.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the XML node to query.</li>
    </ul></dd>
    <dt>Returns: <code class="link">unicode</code></dt>
        <dd>namespace URI of the node or <code class="link">None</code></dd>
  </dl>
</td></tr></table>
</div>
<a name="xml_node_iter"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">xml_node_iter</span>(<span class="sig-arg">nodelist</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_node_iter">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Iterate over sibling XML nodes. All types of nodes will be returned
(not only the elements).</p>
<p>Usually used to iterade over node's children like this:</p>
<pre class="rst-literal-block">
xml_node_iter(node.children)
</pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>nodelist</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : start node of the list.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="xml_element_iter"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">xml_element_iter</span>(<span class="sig-arg">nodelist</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_element_iter">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Iterate over sibling XML elements. Non-element nodes will be skipped.</p>
<p>Usually used to iterade over node's children like this:</p>
<pre class="rst-literal-block">
xml_node_iter(node.children)
</pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>nodelist</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : start node of the list.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="xml_element_ns_iter"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">xml_element_ns_iter</span>(<span class="sig-arg">nodelist</span>,
        <span class="sig-arg">ns_uri</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#xml_element_ns_iter">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Iterate over sibling XML elements. Only elements in the given namespace will be returned.</p>
<p>Usually used to iterade over node's children like this:</p>
<pre class="rst-literal-block">
xml_node_iter(node.children)
</pre>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>nodelist</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : start node of the list.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="safe_serialize"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">safe_serialize</span>(<span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.xmlextra-pysrc.html#safe_serialize">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Serialize an XML element making sure the result is sane.</p>
<p>Remove control characters and invalid namespace declarations from the
result string.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the XML element to serialize.</li>
    </ul></dd>
    <dt>Returns: <code class="link">string</code></dt>
        <dd>UTF-8 encoded serialized and sanitized element.</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== VARIABLES DETAILS ==================== -->
<a name="section-VariablesDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Variables Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-VariablesDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="bad_nsdef_replace_re"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <h3 class="epydoc">bad_nsdef_replace_re</h3>
  
  <dl class="fields">
  </dl>
  <dl class="fields">
    <dt>Value:</dt>
      <dd><table><tr><td><pre class="variable">
re.compile(r'^<code class="re-group">(</code><code class="re-group">[^</code>&lt;<code class="re-group">]</code><code class="re-op">*</code>&lt;<code class="re-group">[</code><code class="re-op">^</code>&gt;&lt;<code class="re-group">]</code><code class="re-op">*</code>\s<code class="re-op">+</code><code class="re-group">)</code><code class="re-group">(</code>xmlns=<code class="re-group">(</code><code class="re-group">(</code>&quot;<code class="re-group">[^</code>&quot;<code class="re-group">]</code><code class="re-op">*</code>&quot;<code class="re-group">)</code><code class="re-op">|</code><code class="re-group">(</code>\'<code class="re-group">[^</code>\'<code class="re-group">]</code><code class="re-op">*</code>\'<code class="re-group">)</code><code class="re-group">)</code><code class="re-group">)</code>')
</pre></td></tr></table>
</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:34:58 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
